Subject: Re: git push doesn't update the status with multiple remotes

From: Garoe <[email-masked]>
Date: Tue, 12 Jul 2016 09:44:59 +0100

Thanks for the quick reply.

On 12/07/16 06:26, Johannes Sixt wrote:
> Am 11.07.2016 um 18:54 schrieb Garoe:
>> I have a repository on github, a clone on my desktop and bare repo on a
>> private server, in my desktop the remotes looks like this
>>
>> all    [email-masked]:user/repo.git (fetch)
>> all    [email-masked]:user/repo.git (push)
>> all    [email-masked]:user/repo.git (push)
>> server    [email-masked]:user/repo.git (fetch)
>> server    [email-masked]:user/repo.git (push)
>> origin    [email-masked]:user/repo.git (fetch)
>> origin    [email-masked]:user/repo.git (push)
>>
>> If I commit to master in my desktop and run 'git push all master', the
>> github and the server repos are correctly updated, but if I run 'git
>> status' the message says:
>>
>> Your branch is ahead of 'origin/master' by 1 commit.
>>   (use "git push" to publish your local commits)
>
> But "all" and "origin" are different remotes. Just because you use the
> same URL does not make them the same remote repository from the view of
> your local repository.

I expected git to be "intelligent" enough to detect that if the url are 
the same, it had already exchanged information with the server by the 
push command, so it would update the message without explicitly pushing 
to origin.

>
> (Additionally, "all" is not a special name, just in case you had
> expected that.)
>
>> The message won't update unless I run git fetch or git push origin
>> master.
>
> Yes, that's how it is supposed to work.

 From my point of view the current behaviour is counter-intuitive. 
Anyhow, I understand by your answer that the current behaviour is 
desired and it won't be changed.

> I think there is some way to configure that a single push command pushes
> to several remote repositories, but I can't find it right now...
>
> -- Hannes
>

Thanks again,
Garoe